// COPn.h: interface for the COPn class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COPN_H__95AE0DB2_AD8B_4965_9531_6CF15F28006C__INCLUDED_)
#define AFX_COPN_H__95AE0DB2_AD8B_4965_9531_6CF15F28006C__INCLUDED_

#include "Database.h"
#include "PnBuffer.h"

class COPn  
{
public:
	void flushTree();
	int COPartition(Record *R, int rLen, int lowerBits, Record *Rout);
	int totalNumBuffers;
//	int boundaryValue;
	int *baseIDList;
	void Pn(Record *R, int rLen);
	void flushAll(int bufID, int level);
	void flush(int bufID, int level);
	int totalTreeLevel;
	int totalHashLevel;
	int totalMask;
	void postInitialize();
	COPn();
	virtual ~COPn();
	LargeVarBuffer **resultBuffers;
	VarBuffer **joinBuffers;
	Record **internalBuffers;
	int *interBufferStatus;
	int *bufSizeList;
	int boundaryRS;

	int COPSort(Record* R, int rLen, Record* output);
	int initialize(int rLen, int totalBits, int numLevel);
};

#endif // !defined(AFX_COPN_H__95AE0DB2_AD8B_4965_9531_6CF15F28006C__INCLUDED_)
