#include "CO_Operators.h"
#include "LinkedList.h"
#include "db.h"
#include "qpUtility.h"
//aggregation
int co_sum(Record *Rin, int rLen)
{
	__DEBUG__("co_sum");
	int i=0;
	int result=0;
	for(i=0; i<rLen; i++)
	{
		result+=Rin[i].value;
	}
	return result;
}
int co_avg(Record *Rin, int rLen)
{
	__DEBUG__("co_avg");
	int i=0;
	//int result=co_sum(Rin,rLen);
	//return result/rLen;
	if(rLen==0)
		return 0;
	double result=(double)Rin[0].value;
	for(i=1;i<rLen;i++)
	{
		result=result/(double)i*(double)(i-1)+Rin[i].value/(double)i;
	}
	return (int)result;
	
}
int co_max(Record *Rin, int rLen)
{
	__DEBUG__("co_max");
	int i=0;
	int maxValue=Rin[0].value;
	for(i=1; i<rLen; i++)
	{
		if(maxValue<Rin[i].value)
			maxValue=Rin[i].value;
	}
	return maxValue;
}
int co_min(Record *Rin, int rLen)
{
	__DEBUG__("co_min");
	int i=0;
	int minValue=Rin[0].value;
	for(i=1; i<rLen; i++)
	{
		if(minValue>Rin[i].value)
			minValue=Rin[i].value;
	}
	return minValue;
}

int co_count(Record *Rin, int rLen)
{
	__DEBUG__("co_count");
	return rLen;
}
int co_distinct(Record *Rin, int rLen, int col, Record **output)
{
	__DEBUG__("co_distinct");
	int result=0;
	if(col==0)//rid.
	{
		Record **Rout=(Record**)malloc(sizeof(Record*));
		co_quickSort(Rin,rLen,Rout,compareRID);
		LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList)); ll->init();
		int i=0;
		int tempValue=Rin[0].rid;
		Record r;
		r.rid=result;
		r.value=(*Rout)[i].rid;
		tempValue=r.rid;
		result++;
		ll->fill(&r);
		for(i=1;i<rLen;i++)
		{
			if((*Rout)[i].rid==tempValue)
				continue;
			else
			{
				r.rid=result;
				r.value=(*Rout)[i].rid;
				result++;
				ll->fill(&r);
				tempValue=(*Rout)[i].rid;
			}
		}
		free(*Rout);
		free(Rout);
		*output=(Record*)malloc(sizeof(Record)*result);
		ll->copyToArray(*output);
		delete ll;
	}
	else
	{		
		Record **Rout=(Record**)malloc(sizeof(Record*));
		co_quickSort(Rin,rLen,Rout,compareRecord);
		LinkedList *ll=(LinkedList*)malloc(sizeof(LinkedList)); ll->init();
		int i=0;
		int tempValue=Rin[0].value;
		Record r;
		r.rid=result;
		r.value=(*Rout)[i].value;
		tempValue=r.value;
		result++;
		ll->fill(&r);
		for(i=1;i<rLen;i++)
		{
			if((*Rout)[i].value==tempValue)
				continue;
			else
			{
				r.rid=result;
				r.value=(*Rout)[i].value;
				result++;
				ll->fill(&r);
				tempValue=(*Rout)[i].value;
			}
		}
		free(*Rout);
		free(Rout);
		*output=(Record*)malloc(sizeof(Record)*result);
		ll->copyToArray(*output);
		delete ll;
	}
	return result;
}

