//#define PCL_LIB
#ifndef MYPCL_H
#define MYPCL_H


#define PCL_CHOICE 2//0


#ifdef PCL_LIB
#include "pcl.h"
#else
#include <time.h>
#endif



class MyPCL
{
public:
	void ClearCache(int size=1024000) {
		int *tmp=new int[size];
		int i=0;
		for(i=0;i<size;i++)
			tmp[i]=i+1;
		delete []tmp;
	}
#ifdef PCL_LIB	
	PCL_CNT_TYPE* i_result;
	PCL_FP_CNT_TYPE* fp_result;
	int* counter_list;
	int res;
	unsigned int flags;
	PCL_DESCR_TYPE descr;
	//staticstics
	
		
	int numPeriod;
	
	
	
	int curPeriod;
	
#else
	//clock_t start,end; 
	double start,end; 
	double startTime;
#endif
	
	void OpenPCL();
	double ClosePCL(int numThread=1);
	void getPCL();
	MyPCL(int numEvents=4);	
	~MyPCL();
	double* total;
	int numEvents;
	float CYC_Count;
	float L2_Count;
	float L1_Count;
	float TLB_Count;
	float oldValue[4];
	//void ClosePCL_noprint();

};

#endif 

