#ifndef PREDICATE_TREE_H
#define PREDICATE_TREE_H

struct PREDICATE_NODE
{
	PREDICATE_NODE * left;
	PREDICATE_NODE * right;
	char opt[20];
};


int evaluate(int * row, PREDICATE_NODE * root);

PREDICATE_NODE * construct_predicate_tree(char * str, int * index, char c[][20], int num);

void delete_predicate_tree(PREDICATE_NODE * node);

int test_predicate_tree();



#endif


