#include "qpUtility.h"
#include "stdlib.h"
#include "string.h"
#include <iostream>
using namespace std;

extern int alphaRatio;
extern int BASESIZE;


int Log2(int num)
{
	int result=0;
	num=num/2;
	while(num!=0)
	{
		result++;
		num=num/2;
	}
	return result;
}
int LogLog2(int num)
{
	return Log2(Log2(num));
}


void checkSorted(Record *R, int rLen)
{
	int i=0;
	for(i=1;i<rLen;i++)
		if(R[i-1].value>R[i].value)
		{
			cout<<"wrong, "<<i-1<<": "<<R[i-1].value<<", "<<R[i].value<<endl;
		}
}

void linux_itoa(int value, char*  str, int radix)
{
    int  rem = 0;
    int  pos = 0;
 
    do
    {
        rem = value % radix ;
        value /= radix;
        str[pos++] = (char) ( rem + '0' );
    }while( value != 0 );
    str[pos] = '\0';
    //str = strrev(str);
    str=linux_strrev(str);
}

char* linux_strrev(char* szT)
{
    if ( !szT )                 // 处理传入的空?
        return "";
    int i = (int)strlen(szT);
    int t = !(i%2)? 1 : 0;      // 检查串长度.
    for(int j = i-1 , k = 0 ; j > (i/2 -t) ; j-- )
    {
        char ch  = szT[j];
        szT[j]   = szT[k];
        szT[k++] = ch;
    }
    return szT;
}

void ComputeVEB(int rLen, int level, int * VEB_SIZE)
{
	int curLevel=0;
	int midLevel=0;
	int deltaLevel=0;
	int temp=0;
	while(curLevel<level)
	{
		deltaLevel=(int)((level-curLevel)/2.0);
		midLevel=curLevel+deltaLevel;
#ifdef DEBUG
		cout<<"curLevel, "<<curLevel<<", daltaLevel, "<<deltaLevel<<", midLevel, "<<midLevel<<endl;
#endif		
		DirectComputeVEB(midLevel,VEB_SIZE+curLevel);
		temp=(int)(deltaLevel*pow(2.0,(double)(deltaLevel+1))*alphaRatio);
		if(temp<2*rLen/(1<<midLevel))
		VEB_SIZE[midLevel]=temp;
		else
		VEB_SIZE[midLevel]=2*rLen/(1<<midLevel);
		//cout<<midLevel<<", "<<VEB_SIZE[midLevel]<<endl;
		curLevel=midLevel+1;
	
	}
	//if(VEB_SIZE[level-1]<2*alphaRatio)
	//VEB_SIZE[level-1]=2*alphaRatio;
	//	VEB_SIZE[level-1]=1<<(DIRECT_LEVEL+HASH_BUCKET_BITS);
		VEB_SIZE[level-1]=(1<<(DIRECT_LEVEL))*alphaRatio;
		//VEB_SIZE[5]*=
	//DirectComputeVEB(level, VEB_SIZE);

	
		
}




void DirectComputeVEB(int level, int * VEB_SIZE)
{
	int upper=level;
	int lower=0; 
	int temp=0;
	double fanout=2;
	int total=(int)pow(fanout,(double)level);
	int tempTotal=total;
	struct VEBLH{
		int lower;
		int upper;
	};

	VEBLH *mystack=new VEBLH[level];
	int top=0;
	mystack[top].lower=0;
	mystack[top].upper=level-1;
	top++;
	int curLevel=0;
	while(top!=0)
	{
		lower=mystack[top-1].lower;
		upper=mystack[top-1].upper;
		top--;
		if(lower==upper)
			VEB_SIZE[lower]=BASESIZE;//2*alphaRatio;//
		else
		{
			curLevel=(int)ceil((double)(upper+lower)/2.0);
			//VEB_SIZE[curLevel]=alphaRatio*ceil(pow((double)fanout, (double)(upper-lower+1)))*ceil((double)(upper-lower+1));//(upper-curLevel+1)*pow(fanout, (double)(upper-curLevel+1));
			VEB_SIZE[curLevel]=(int)(BASESIZE/2*(double)(upper-lower+1)*ceil(pow((double)fanout, (double)(upper-lower+1))));
			if(VEB_SIZE[curLevel]<BASESIZE)
				VEB_SIZE[curLevel]=BASESIZE;
			if(curLevel>lower)
			{
				mystack[top].lower=lower;
				mystack[top].upper=curLevel-1;
				top++;
			}

			if(curLevel<upper)
			{
				mystack[top].lower=curLevel+1;
				mystack[top].upper=upper;
				top++;
			}

		}
	}	
}


bool is2n(unsigned int i)
{
    if(i==0) return false;    
    else return (i&(i-1))==0;
}

//compute the VEB size for [fromLevel, toLevel)
void NewVEB(int fromLevel, int toLevel, int totalLevel, int *VEBSIZE)
{
	if((fromLevel+1)==toLevel)
	{
		VEBSIZE[fromLevel]=BASESIZE;//*(totalLevel-fromLevel);
	}
	else
	{
		int midLevel=(fromLevel+toLevel)/2;
		//the bottom tree (midLevel, toLevel)
		int numNodeInBottomTree=1<<(toLevel-midLevel+1);
		VEBSIZE[midLevel]=alphaRatio*numNodeInBottomTree*(toLevel-midLevel);
		//recursion
		if(midLevel>fromLevel)
			NewVEB(fromLevel, midLevel, totalLevel, VEBSIZE);
		if(toLevel>(midLevel+1))
			NewVEB(midLevel+1, toLevel, totalLevel, VEBSIZE);
	}
	
}
