#ifndef CCHashTable_H
#define CCHashTable_H

#include "db.h"
#include "LinkedList.h"
//#pragma once

#define BUCKET_SIZE 8

class CCHashTable
{
public:
	CCHashTable(int cap);
	~CCHashTable(void);
	LinkedList ** ht;
	int numBuckets;
	int numBits;

	void insertKey(Record* r);
	// probe a tuple against the hash table and store the results into Rout
	int probe(Record* r, Record** Rout);
};

#endif

