#ifndef COHashTable_H
#define COHashTable_H

#include "db.h"
#include "LinkedList.h"
//#pragma once

#define BUCKET_SIZE 4

class COHashTable
{
public:
	COHashTable(int cap);
	~COHashTable(void);
	LinkedList ** ht;
	int numBuckets;
	int numBits;

	void insertKey(Record* r);
	// probe a tuple against the hash table and store the results into Rout
	int probe(Record* r, Record** Rout);
};

#endif

