#ifndef EXEC_STATUS
#define EXEC_STATUS

#include "stdlib.h"
#include "stdio.h"
#include "string.h"
#include "db.h"
#include "qpUtility.h"

struct ExecStatus
{
//attributes,
	char baseTables [MAX_TABLE_PER_QUERY][NAME_MAX_LENGTH];
	int* RID_baseTable [MAX_TABLE_PER_QUERY];
	int RIDLen[MAX_TABLE_PER_QUERY];
	int numTables;
	int* finalResult;
	int numResultColumn;
	int numResultRow;
	int treeMode;
//methods,
	int getBaseTable(char* tableName)
	{
		int id=-1;
		for(int i=0;i<numTables;i++)
		{
			if(strcmp(tableName,baseTables[i])==0)
			{
				id=i;
				break;
			}
		}
		return id;	
	}
	int addBaseTable(char * tableName, int *RIDArray, int rLen)
	{
		strcpy(baseTables[numTables],tableName);
		RID_baseTable[numTables]=RIDArray;
		RIDLen[numTables]=rLen;
		numTables++;
		return (numTables-1);
	}
	void init(bool tM=CC_EXEC)
	{
		treeMode=tM;
		numTables=0;
		for(int i=0;i<MAX_TABLE_PER_QUERY;i++)
		{
			RID_baseTable[i]=NULL;
		}
		finalResult=NULL;
		numResultColumn=-1;
		numResultRow=-1;
	}
	void destory()
	{
	}
};


#endif


