#include <string.h>
#include "QueryPlanTree.h"
#include "stdlib.h"
#include "stdio.h"
#include "string.h"
void QueryPlanTree::buildTree(char * str)
{
	int i = 0;
	root = construct_plan_tree(str, &i);
}

QueryPlanNode * QueryPlanTree::construct_plan_tree(char * str, int * index)
{
	int i, j = *index;
	
	 if (str[j] == '$')
	{
		*index = j + 2;
		return NULL;
	}


	QueryPlanNode * node = new QueryPlanNode();

	for (i = j; str[i] != '\0'; i++)
	{
		if (str[i] == ':')
			break;
	}
	node->initialNode((char*)(str + j),this->planStatus,treeMode);
	i++;

	//recursive
	node->left = construct_plan_tree(str, &i);
	node->right = construct_plan_tree(str, &i);
	*index = i;
	return node;
}

void QueryPlanTree::execute()
{
	if (root == NULL)
		return;

	int level=0;
	root->execute(level);
}

