#ifndef QUERYPLANTREE_H
#define QUERYPLANTREE_H

#include "db.h"
#include "stdlib.h"
#include "QueryPlanNode.h"
#include "ExecStatus.h"


class QueryPlanTree
{
protected:
	

public:
	void buildTree(char * str);
	bool treeMode;
	ExecStatus* planStatus;
	void execute();
	QueryPlanTree(bool tM=CC_EXEC)
	{
		root=NULL;
		treeMode=tM;	
		planStatus=(ExecStatus*)malloc(sizeof(ExecStatus));
		planStatus->init();
	}
	~QueryPlanTree()
	{
		free(planStatus);
	}



	QueryPlanNode * QueryPlanTree::construct_plan_tree(char * str, int * index);
	QueryPlanNode * root;

};

#endif

