#ifndef ROW_EXEC_H
#define ROW_EXEC_H
#pragma once

//This is for the row-based storage. We can use column-based as well.
#include "DBArray.h"
#include "db.h"

int dba_sum(DBArray *Rin, int rLen, int attrIndex);
int dba_avg(DBArray *Rin, int rLen, int attrIndex);
int dba_max(DBArray *Rin, int rLen, int attrIndex);
int dba_min(DBArray *Rin, int rLen, int attrIndex);
int dba_count(DBArray *Rin, int rLen, int attrIndex);
int dba_distinct(DBArray *Rin, int rLen, int attrIndex, DBArray *output, bool mode=CC_EXEC);

//for testing.
int dba_sort(DBArray *R, int attrIndex, DBArray *output, bool mode=CC_EXEC);
int dba_ninlj(DBArray *R, DBArray *S, bool mode=CC_EXEC);
int dba_inlj(DBArray *R,int attrIndex1, DBArray *S, int attrIndex2,bool mode);
int dba_smj(DBArray *R,int attrIndex1, DBArray *S, int attrIndex2,bool mode);
int dba_hj(DBArray *R,int attrIndex1, DBArray *S, int attrIndex2,bool mode);

#endif

